﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NUnit.Framework;

using MiscUtil.Collections.Extensions;

namespace MiscUtil.UnitTests.Collections.Extensions
{
    [TestFixture]
    public class ComparerExtTest
    {
        [Test]
        public void DoubleReverseIsNoOp()
        {
            var original = StringComparer.Ordinal;

            Assert.AreSame(original, original.Reverse().Reverse());
        }

        [Test]
        public void SingleReverseReverses()
        {
            var original = StringComparer.Ordinal;
            var subject = original.Reverse();

            Assert.AreEqual(original.Compare("x", "y"), subject.Compare("y", "x"));
            Assert.AreEqual(0, subject.Compare("x", "x"));
        }
    }
}
